<style lang="scss">
  .wrapper {
    min-height: 100px;
  }

  #commit {
    overflow-x: auto;

    .header {
      a {
        color: inherit;
        text-decoration: none;
      }

      i {
        color: #333;
        padding: 0 16px;

        &:first-child {
          padding-left: 0;
        }
      }
    }

    .message-holder {
      padding-top: 24px;
      padding-bottom: 8px;

      .q-item-sublabel {
        white-space: pre;
      }
    }

    .file {
      a {
        color: #004ac7;
      }

      .changes {
        i {
          padding: 16px;
        }

        .additions i {
          color: green;
        }

        .deletions i {
          color: red;
        }
      }
    }

    pre {
      margin: 0;

      &#full-commit {
        background: #eee;
        padding: 4px;
        font-size: 70%;
      }
    }
  }
</style>

<template>
  <div class="wrapper">
    <q-card id="commit">
      <q-card-main>
        <div class="row items-center justify-between header">
          <div class="row items-center">
            <q-icon name="access_time"/> {{ commit.commit.author.date | formatToDateAndHour }}
            <q-icon name="person"/> {{ commit.commit.author.name }}
            <q-icon name="email"/> <a v-bind:href="'mailto:' + commit.commit.author.email"
                                      target="_blank" rel="noopener noreferrer">{{ commit.commit.author.email }}</a>
          </div>
          <a v-bind:href="commit.html_url" target="_blank" rel="noopener noreferrer">
            <q-icon name="open_in_new" size="16px"/>
          </a>
        </div>

        <q-collapsible v-bind:sublabel="commit.commit.message" sublabel-lines="6" class="message-holder">
          <pre><code><br>{{ commit.commit.message }}</code></pre>
        </q-collapsible>

        <div v-for="file in commit.files" :key="file.sha" class="file">
          <div class="row changes items-center justify-between">
            <a v-bind:href="file.blob_url" target="_blank" rel="noopener noreferrer">
              <code><pre>{{ file.filename }}</pre></code>
            </a>
            <div class="row">
              <div class="row items-center additions"><q-icon name="add_circle"/><span>{{ file.additions }}</span></div>
              <div class="row items-center deletions"><q-icon name="remove_circle"/><span>{{ file.deletions }}</span></div>
            </div>
          </div>

          <code-highlight v-bind:patch="file.patch" :key="file.sha"></code-highlight>
        </div>
      </q-card-main>

      <q-collapsible icon="explore" label="Full Commit">
        <pre id="full-commit">{{ getJSONString(commit) }}</pre>
      </q-collapsible>
    </q-card>
  </div>
</template>

<script>
import { QCard, QCardMain, QCollapsible, QCardTitle, QIcon } from 'quasar';
import CodeHighlight from './CodeHighlight.vue';

export default {
  props: ['commit'],
  methods: {
    getJSONString(object) {
      return JSON.stringify(object, null, 2);
    },
  },
  components: {
    QCard, QCardMain, QCollapsible, QCardTitle, QIcon, CodeHighlight,
  },
};
</script>
